<template>
  <q-layout view="lHh Lpr lFf">
    <q-header elevated>
      <q-toolbar>
        <q-btn
          flat
          dense
          @click="toggleLeftDrawer()"
          round
          icon="menu"
          aria-label="Menu"
        />

        <q-toolbar-title>Quasar App</q-toolbar-title>

        <div>Quasar v{{ version }}</div>
      </q-toolbar>
    </q-header>

    <q-drawer
      bordered
      show-if-above
      v-model="leftDrawerOpen"
    >
      <q-list>
        <q-item-label
          class="text-grey-8"
          header
        >
          {{$t('left-drawer.title')}}
        </q-item-label>
        <essential-link
          v-for="link in essentialLinks"
          :key="link.title"
          v-bind="link"
        />
      </q-list>
    </q-drawer>

    <q-page-container>
      <router-view />
    </q-page-container>
  </q-layout>
</template>

<script lang="ts">
import Vue from 'vue';

import ConfigStore from '../store/config';
import EssentialLink from 'components/EssentialLink.vue';
import { version } from '../../package.json';

export default Vue.extend({
  components: {
    EssentialLink,
  },

  computed: {
    leftDrawerOpen: {
      get() {
        return ConfigStore.getters.isLeftDrawerOpen;
      },
      set(newValue: boolean) {
        ConfigStore.actions.setLeftDrawerOpen(newValue);
      },
    },
  },

  data() {
    return {
      essentialLinks: [
        {
          title: this.$t('pages.home.title'),
          caption: this.$t('pages.home.caption'),
          icon: 'home',
          link: '/',
        },
        {
          title: this.$t('pages.settings.title'),
          caption: this.$t('pages.settings.caption'),
          icon: 'settings',
          link: '/settings',
        },
        {
          title: this.$t('pages.about.title'),
          caption: this.$t('pages.about.caption'),
          icon: 'info',
          link: '/about',
        },
      ],
      version,
    };
  },
  methods: {
    toggleLeftDrawer: ConfigStore.actions.toggleLeftDrawer,
  },
  name: 'MainLayout',
});
</script>
